/*==============================================================================
*NOME:   TRAB1.C
*
*  Projeto: Reduo para 256 cores
*
*  Verso:              V 1.00
*  Autor :   Juliana Carpes Imperial        - 9714169-4
*
*Descrio do mdulo de implementao
*     Objetivo:
*        - Implementar o programa principal utilizando as funes definidas em
*          IMAGE.H e REDUZCOR.C. que recebe como entrada um arquivo para uma
*          imagem e gera um outro arquivo com uma outra imagem de mesma
*          resoluo espacial, mas com apenas 256 cores.
*=============================================================================*/


#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "image.h"
#include "reduzcor.h"


#define SZ_FORMATO "Formato: REDUZCOR IMG IMG256"

int main( int argc     ,
          char* argv[ ] ) {

   double  time  ;
   clock_t time0 , 
	       time1 ;

   if ( argc == 3 ) {  /* testa se o formato da linha de comando est correto */
      Image* pImagem = imgReadPPM( argv[ 1 ] ) ;  /* l imagem */

      if ( pImagem != NULL ) { /* testa se foi possvel ler a imagem */
         time0=clock();
		 pImagem = imgReduceTo256( pImagem ) ; /* reduz as cores da imagem */
         time1 = clock( ) ;
	     time = ( double )( time1-time0 ) / CLOCKS_PER_SEC ;
		 imgWritePPM( pImagem, argv[ 2 ] ) ;  /* grava imagem em novo arquivo */
         imgDestroy( pImagem ) ;              /* destroi a imagem */
          printf( "%lf\n", time ) ;
	  } /* if */

   } else {
      puts( SZ_FORMATO ) ;
   } /* if */

   return 0 ;

}


/* trab1.c */
